// 获取到字符串
function getSubstring(text, begin, finish, boole=true) {
	var e, f, g;
	return void 0 == text || null == text || "" == text ? "" : (e = text.indexOf(begin), e >= 0 ? (f = text.indexOf(finish, e + begin.length), g = text.substring(e + begin.length, f), boole && (g = g.replace(/<[^>]+>/g, "")), $.trim(g)) : "")
}

/**
 *对Date的扩展，将 Date 转化为指定格式的String
 *月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，
 *年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
 *例子：
 *(new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
 *(new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18
 */
Date.prototype.format = function (fmt) {
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

function toHanzi(a) {
	try {
		var b = a.replace(/\\/g, "%");
		return b = unescape(b)
	} catch (c) {
		return a
	}
}

// 获取url参数
function getQueryVariable(url, key)
{
       // var query = window.location.search.substring(1);
       var query = url.split('?');
       var vars = query[1].split("&");
       for (var i=0;i<vars.length;i++) {
               var pair = vars[i].split("=");
               if(pair[0] == key){return pair[1];}
       }
       return(false);
}

// 请求接口
function requestInterface(url, method, data={}, type='GET'){
    $.ajax({
        url: url,
        type: type,
        data: data,
        complete: function(json) {
            method({status: json.status,
                statusText: json.statusText,
                text: json.responseText,
                json: json.responseJSON
            })
        }
    })
}

// 提示框
function promptBox(content, style='success', contentDetail=''){
    if(style=='success'){
        zeroModal.success({
            content: content,
            width: '350px',
            height: '185px',
            ok: false
        })
    }else if(style=='error'){
        zeroModal.error({
            content: content,
            width: '350px',
            height: '185px',
            ok: false
        })
    }else{
        zeroModal.alert({
            content: content,
            contentDetail: contentDetail,
            width: '350px',
            height: '185px',
            ok: false
        })
    }
}